if select(2,UnitClass("player")) ~= "MONK" then return end
local LibStub = LibStub
local AceAddon = LibStub("AceAddon-3.0")
local string_match= string.match
local tonumber = tonumber
local GetCVar = GetCVar
local min = min
local max = max
local LSM = LibStub("LibSharedMedia-3.0")

local RemUplift = AceAddon:NewAddon("RemUplift", "AceEvent-3.0","AceConsole-3.0")

local cvar_width,cvar_height = string_match(GetCVar("gxResolution"), "(%d+)x(%d+)")
cvar_width = tonumber(cvar_width)
cvar_height = tonumber(cvar_height)
local cvar_min = min(cvar_width,cvar_height)
--------------------------------------------------------------------------------------
local AceDB = LibStub("AceDB-3.0")
local AceConfigDialog = LibStub("AceConfigDialog-3.0")
local AceConfigCmd = LibStub("AceConfigCmd-3.0")
--------------------------------------------------------------------------------------

local default_options=
{
	profile = 
	{
		lock = false,
		worldPVP = true,
		autoHide = false,
		ashran = true,
		rem_pos_left = cvar_width / 2 ,
		rem_pos_top = cvar_height / 2,
		uplift_pos_left = cvar_width / 2 ,
		uplift_pos_top = cvar_height / 2,
		refreshRate = 0.1,
		remCounterFont = LSM:GetDefault("font"),
		remCounterFontSize = 30, 
		iconSize = 65,
		remMinDurationFont = LSM:GetDefault("font"),
		remMinDurationFontSize = 15,
		upliftBarWidth = 150,
		upliftBarHeight = 40,
--		upliftMidEf = 40,
--		upliftHgEf = 80,
		upliftPercentageFont = LSM:GetDefault("font"),
		upliftPercentageFontSize = 15,
		upliftAmountFont = LSM:GetDefault("font"),
		upliftAmountFontSize = 15,
		upliftPredictFactor = 1,

		extendLifeEnable = false,
		extendLifeCounterPosLeft = cvar_width/3,
		extendLifeCounterPosTop = cvar_height/3,
		extendLifeCounterFont = LSM:GetDefault("font"),
		extendLifeCounterFontSize = 30, 
		extendLifeIconSize = 65,
		extendLifeMinDurationFont = LSM:GetDefault("font"),
		extendLifeMinDurationFontSize = 15,
		
		upliftELPosLeft = cvar_width / 3 ,
		upliftELPosTop = cvar_height / 3,
		upliftELBarWidth = 150,
		upliftELBarHeight = 40,
		upliftELPercentageFont = LSM:GetDefault("font"),
		upliftELPercentageFontSize = 15,
		upliftELAmountFont = LSM:GetDefault("font"),
		upliftELAmountFontSize = 15,
	}
}

function RemUplift:OnInitialize()
	RemUplift.db = AceDB:New("RemUpliftDB",default_options,true)
	self:OnCoreInitialize()
	self:RegisterChatCommand("RemUplift", "ChatCommand")
	self:RegisterEvent("PLAYER_SPECIALIZATION_CHANGED")
	self:RegisterEvent("PLAYER_ENTERING_WORLD","PLAYER_SPECIALIZATION_CHANGED")
end

function RemUplift:ChatCommand(input)
	if IsAddOnLoaded("RemUplift_Options") == false then
		local loaded , reason = LoadAddOn("RemUplift_Options")
		if loaded == false then
			self:Print("RemUplift_Options: "..reason)
			return
		end
	end
	if not input or input:trim() == "" then
		AceConfigDialog:Open("RemUplift")
	else
		AceConfigCmd:HandleCommand("RemUplift", "RemUplift","")
		AceConfigCmd:HandleCommand("RemUplift", "RemUplift",input)
	end
end