if select(2,UnitClass("player")) ~= "MONK" then return end
local LibStub = LibStub
local AceAddon = LibStub("AceAddon-3.0")
local RemUplift = AceAddon:GetAddon("RemUplift")
--------------------------------------------------------------------------------------
local GetSpellInfo = GetSpellInfo
local CreateFrame = CreateFrame
local UnitGUID = UnitGUID
local UnitBuff = UnitBuff
local UnitInRaid = UnitInRaid
local UnitInParty = UnitInParty
local GetTime = GetTime
local UnitHealth = UnitHealth
local UnitHealthMax = UnitHealthMax
local UnitGetIncomingHeals = UnitGetIncomingHeals
local UnitIsEnemy = UnitIsEnemy
local GetNumGroupMembers = GetNumGroupMembers
local GetSpecialization = GetSpecialization
local UnitIsPVP = UnitIsPVP
local next = next
local select = select
local min = min
local max = max
local string_format = string.format
local LSM = LibStub("LibSharedMedia-3.0")

local rem_frame
local uplift_frame

local el_frame
local el_icon
local el_counter
local el_min_duration
local el_bg
local el_texture = select(3,GetSpellInfo(185158))
local el_enable
local eluplift_frame
local eluplift_bg
local eluplift_status_bar
local eluplift_amount
local eluplift_percentage

function RemUplift:UpdateELIconPosition()
	el_frame:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT",RemUplift.db.profile.extendLifeCounterPosLeft,RemUplift.db.profile.extendLifeCounterPosTop)
end
function RemUplift:UpdateELIconSize()
	el_frame:SetSize(RemUplift.db.profile.extendLifeIconSize,RemUplift.db.profile.extendLifeIconSize) 
	el_icon:SetSize(RemUplift.db.profile.extendLifeIconSize-4,RemUplift.db.profile.extendLifeIconSize-4)
end
function RemUplift:UpdateELCounterFont()
	el_counter:SetFont(LSM:HashTable("font")[RemUplift.db.profile.extendLifeCounterFont], RemUplift.db.profile.extendLifeCounterFontSize, "OUTLINE")
end
function RemUplift:UpdateELMinDurationFont()
	el_min_duration:SetFont(LSM:HashTable("font")[RemUplift.db.profile.extendLifeMinDurationFont], RemUplift.db.profile.extendLifeMinDurationFontSize, "OUTLINE")
end
function RemUplift:UpdateEnableEL()
	el_enable = RemUplift.db.profile.extendLifeEnable
end
function RemUplift:UpdateUpliftELStatusBarPosition()
	eluplift_frame:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT",RemUplift.db.profile.upliftELPosLeft,RemUplift.db.profile.upliftELPosTop)
end
function RemUplift:UpdateUpliftELStatusBarSize()
	eluplift_frame:SetSize(RemUplift.db.profile.upliftELBarWidth,RemUplift.db.profile.upliftELBarHeight)
	eluplift_status_bar:SetSize(RemUplift.db.profile.upliftELBarWidth-4,RemUplift.db.profile.upliftELBarHeight-4)
end
function RemUplift:UpdateUpliftELPercentageFont()
	eluplift_percentage:SetFont(LSM:HashTable("font")[RemUplift.db.profile.upliftELPercentageFont], RemUplift.db.profile.upliftELPercentageFontSize, "OUTLINE")
end
function RemUplift:UpdateUpliftELAmountFont()
	eluplift_amount:SetFont(LSM:HashTable("font")[RemUplift.db.profile.upliftELAmountFont], RemUplift.db.profile.upliftELAmountFontSize, "OUTLINE")
end

local rem_texture = select(3,GetSpellInfo(115151))
local statusbar_texture ="Interface\\TargetingFrame\\UI-StatusBar"

local function cons_scr()
	rem_frame:SetScript("OnMouseDown", function() rem_frame:StartMoving() end)
	rem_frame:SetScript("OnMouseUp",
	function()
		rem_frame:StopMovingOrSizing()
		RemUplift.db.profile.rem_pos_left = rem_frame:GetLeft()
		RemUplift.db.profile.rem_pos_top = rem_frame:GetTop()
	end)
	rem_frame:SetScript("OnDragStop", function() rem_frame:StopMovingOrSizing() end)
	uplift_frame:SetScript("OnMouseDown", function() uplift_frame:StartMoving() end)
	uplift_frame:SetScript("OnMouseUp",
	function()
		uplift_frame:StopMovingOrSizing()
		RemUplift.db.profile.uplift_pos_left = uplift_frame:GetLeft()
		RemUplift.db.profile.uplift_pos_top = uplift_frame:GetTop()
	end)
	uplift_frame:SetScript("OnDragStop", function() uplift_frame:StopMovingOrSizing() end)
	el_frame:SetScript("OnMouseDown", function() el_frame:StartMoving() end)
	el_frame:SetScript("OnMouseUp",
	function()
		el_frame:StopMovingOrSizing()
		RemUplift.db.profile.extendLifeCounterPosLeft = el_frame:GetLeft()
		RemUplift.db.profile.extendLifeCounterPosTop = el_frame:GetTop()
	end)
	eluplift_frame:SetScript("OnDragStop", function() eluplift_frame:StopMovingOrSizing() end)
	eluplift_frame:SetScript("OnMouseDown", function() eluplift_frame:StartMoving() end)
	eluplift_frame:SetScript("OnMouseUp",
	function()
		eluplift_frame:StopMovingOrSizing()
		RemUplift.db.profile.extendLifeCounterPosLeft = eluplift_frame:GetLeft()
		RemUplift.db.profile.extendLifeCounterPosTop = eluplift_frame:GetTop()
	end)
	eluplift_frame:SetScript("OnDragStop", function() eluplift_frame:StopMovingOrSizing() end)
end

function RemUplift:UpdateLock()
	if not RemUplift.db.profile.lock then
		rem_frame:SetMovable(true)
		rem_frame:EnableMouse(true)
		uplift_frame:SetMovable(true)
		uplift_frame:EnableMouse(true)
		el_frame:SetMovable(true)
		el_frame:EnableMouse(true)
		eluplift_frame:SetMovable(true)
		eluplift_frame:EnableMouse(true)
	else
		rem_frame:SetMovable(false)
		rem_frame:EnableMouse(false)
		uplift_frame:SetMovable(false)
		uplift_frame:EnableMouse(false)
		el_frame:SetMovable(false)
		el_frame:EnableMouse(false)
		eluplift_frame:SetMovable(false)
		eluplift_frame:EnableMouse(false)
	end
end

local rem_icon
local rem_counter
local rem_min_duration
local rem_bg
local uplift_bg
local uplift_status_bar
local uplift_amount
local uplift_percentage
local refresh_rate
local now_timer
local uplift_predict_factor
local world_pvp
local ashran
local auto_hide
local unordered_map = {}
function RemUplift:UpdateRemIconPosition()
	rem_frame:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT",RemUplift.db.profile.rem_pos_left,RemUplift.db.profile.rem_pos_top)
end
function RemUplift:UpdateRemIconSize()
	rem_frame:SetSize(RemUplift.db.profile.iconSize,RemUplift.db.profile.iconSize) 
	rem_icon:SetSize(RemUplift.db.profile.iconSize-4,RemUplift.db.profile.iconSize-4)
end
function RemUplift:UpdateRemCounterFont()
	rem_counter:SetFont(LSM:HashTable("font")[RemUplift.db.profile.remCounterFont], RemUplift.db.profile.remCounterFontSize, "OUTLINE")
end
function RemUplift:UpdateRemMinDurationFont()
	rem_min_duration:SetFont(LSM:HashTable("font")[RemUplift.db.profile.remMinDurationFont], RemUplift.db.profile.remMinDurationFontSize, "OUTLINE")
end
function RemUplift:UpdateUpliftStatusBarPosition()
	uplift_frame:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT",RemUplift.db.profile.uplift_pos_left,RemUplift.db.profile.uplift_pos_top)
end
function RemUplift:UpdateUpliftStatusBarSize()
	uplift_frame:SetSize(RemUplift.db.profile.upliftBarWidth,RemUplift.db.profile.upliftBarHeight)
	uplift_status_bar:SetSize(RemUplift.db.profile.upliftBarWidth-4,RemUplift.db.profile.upliftBarHeight-4)
end
function RemUplift:UpdateUpliftPercentageFont()
	uplift_percentage:SetFont(LSM:HashTable("font")[RemUplift.db.profile.upliftPercentageFont], RemUplift.db.profile.upliftPercentageFontSize, "OUTLINE")
end
function RemUplift:UpdateUpliftAmountFont()
	uplift_amount:SetFont(LSM:HashTable("font")[RemUplift.db.profile.upliftAmountFont], RemUplift.db.profile.upliftAmountFontSize, "OUTLINE")
end
function RemUplift:UpdateRefreshRate()
	refresh_rate=RemUplift.db.profile.refreshRate
	now_timer = 0
end
function RemUplift:UpdatePredictFactor()
	uplift_predict_factor=RemUplift.db.profile.upliftPredictFactor
end
function RemUplift:UpdateAshran()
	ashran = RemUplift.db.profile.ashran
end
function RemUplift:UpdateWorldPVP()
	world_pvp = RemUplift.db.profile.worldPVP
	if world_pvp == true then
		self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	else
		self:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		unordered_map = {}
	end
end
function RemUplift:UpdateAutoHide()
	auto_hide = RemUplift.db.profile.autoHide
end
function RemUplift:UpdateDB()
	self:UpdateLock()
	self:UpdateRemIconPosition()
	self:UpdateRemIconSize()
	self:UpdateRemCounterFont()
	self:UpdateRemMinDurationFont()
	self:UpdateUpliftStatusBarPosition()
	self:UpdateUpliftStatusBarSize()
	self:UpdateUpliftPercentageFont()
	self:UpdateUpliftAmountFont()
	
	self:UpdateEnableEL()
	self:UpdateELIconPosition()
	self:UpdateELIconSize()
	self:UpdateELCounterFont()
	self:UpdateELMinDurationFont()
	self:UpdateUpliftELStatusBarPosition()
	self:UpdateUpliftELStatusBarSize()
	self:UpdateUpliftELPercentageFont()
	self:UpdateUpliftELAmountFont()
	
	self:UpdateRefreshRate()
	self:UpdatePredictFactor()
	self:UpdateWorldPVP()
	self:UpdateAshran()
	self:UpdateAutoHide()
end
function RemUplift:OnCoreInitialize()
	rem_frame = CreateFrame("Frame",nil,UIParent)
	rem_frame:SetFrameStrata("MEDIUM")
	rem_frame:SetClampedToScreen(true)
	rem_bg =  rem_frame : CreateTexture(nil, "BACKGROUND")
	rem_bg:SetAllPoints(rem_frame)
	rem_bg:SetTexture(statusbar_texture)
	rem_bg:SetVertexColor(0,0,0,1)
	rem_icon =  rem_frame : CreateTexture(nil, "BORDER")
	rem_icon:SetPoint("CENTER", rem_frame, "CENTER",0,0)
	rem_icon:SetTexture(rem_texture)
	rem_icon:SetTexCoord(0.1,0.9,0.1,0.9)
	rem_icon:SetVertexColor(1,1,1,1)
	rem_counter = rem_frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightSmall")
	rem_counter:SetPoint("CENTER", rem_frame, "CENTER",0, 0)
	rem_min_duration = rem_frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightSmall")
	rem_min_duration:SetPoint("BOTTOM", rem_frame, "BOTTOM",0,5)
	uplift_frame = CreateFrame("Frame",nil,UIParent)
	uplift_frame:SetFrameStrata("MEDIUM")
	uplift_frame:SetClampedToScreen(true)
	uplift_bg =  uplift_frame : CreateTexture(nil, "BACKGROUND")
	uplift_bg:SetAllPoints(uplift_frame)
	uplift_bg:SetTexture(statusbar_texture)
	uplift_bg:SetVertexColor(0,0,0,1)
	uplift_status_bar =  CreateFrame("StatusBar",nil,uplift_frame)
	uplift_status_bar:SetPoint("CENTER", uplift_frame, "CENTER",0,0)
	uplift_status_bar:SetStatusBarTexture(statusbar_texture)
	uplift_status_bar:SetFrameLevel(uplift_status_bar:GetFrameLevel()-1)
	uplift_status_bar:SetMinMaxValues(0,100)
	uplift_percentage = uplift_frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightSmall")
	uplift_percentage:SetPoint("RIGHT", uplift_frame, "RIGHT",0, 0)
	uplift_amount = uplift_frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightSmall")
	uplift_amount:SetPoint("RIGHT", uplift_frame, "CENTER",0, 0)
	
	el_frame = CreateFrame("Frame",nil,UIParent)
	el_frame:SetFrameStrata("MEDIUM")
	el_frame:SetClampedToScreen(true)
	el_bg = el_frame : CreateTexture(nil, "BACKGROUND")
	el_bg:SetAllPoints(el_frame)
	el_bg:SetTexture(statusbar_texture)
	el_bg:SetVertexColor(0,0,0,1)
	el_icon =  el_frame : CreateTexture(nil, "BORDER")
	el_icon:SetPoint("CENTER", el_frame, "CENTER",0,0)
	el_icon:SetTexture(el_texture)
	el_icon:SetTexCoord(0.1,0.9,0.1,0.9)
	el_icon:SetVertexColor(1,1,1,1)
	el_counter = el_frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightSmall")
	el_counter:SetPoint("CENTER", el_frame, "CENTER",0, 0)
	el_min_duration = el_frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightSmall")
	el_min_duration:SetPoint("BOTTOM", el_frame, "BOTTOM",0,5)
	
	eluplift_frame = CreateFrame("Frame",nil,UIParent)
	eluplift_frame:SetFrameStrata("MEDIUM")
	eluplift_frame:SetClampedToScreen(true)
	eluplift_bg =  eluplift_frame : CreateTexture(nil, "BACKGROUND")
	eluplift_bg:SetAllPoints(eluplift_frame)
	eluplift_bg:SetTexture(statusbar_texture)
	eluplift_bg:SetVertexColor(0,0,0,1)
	eluplift_status_bar =  CreateFrame("StatusBar",nil,eluplift_frame)
	eluplift_status_bar:SetPoint("CENTER", eluplift_frame, "CENTER",0,0)
	eluplift_status_bar:SetStatusBarTexture(statusbar_texture)
	eluplift_status_bar:SetFrameLevel(eluplift_status_bar:GetFrameLevel()-1)
	eluplift_status_bar:SetMinMaxValues(0,100)
	eluplift_percentage = eluplift_frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightSmall")
	eluplift_percentage:SetPoint("RIGHT", eluplift_frame, "RIGHT",0, 0)
	eluplift_amount = eluplift_frame:CreateFontString(nil, "OVERLAY", "GameFontHighlightSmall")
	eluplift_amount:SetPoint("RIGHT", eluplift_frame, "CENTER",0, 0)
	
	rem_frame:Hide()
	uplift_frame:Hide()
	el_frame:Hide()
	eluplift_frame:Hide()
	cons_scr()
	
	self:UpdateDB()
end

local rem_info = GetSpellInfo(119611)

local start_event_time
function RemUplift:COMBAT_LOG_EVENT_UNFILTERED(...)
	local spell_caster = select(5, ...)
	local player_guid = UnitGUID("player")
	if spell_caster == player_guid  then
		local event_time = select(2,...)
		local battle_message = select(3, ...)
		local spell_id  =  select(13, ...)
		local dst_guid = select(9,...)
		local dst_name = select(10,...)
		if spell_id == 119611 and(dst_guid ~= player_guid) then
			if battle_message == "SPELL_AURA_REMOVED" then
				unordered_map[dst_name] = nil
			elseif battle_message == "SPELL_AURA_APPLIED" then
				if(start_event_time==nil) then
					start_event_time = GetTime() - event_time
				end
				unordered_map[dst_name] = event_time + start_event_time +20
			end
		end
	end
end
local function mscr_pvp(ms,crit,hd,raw_healing)
	local nocr = 1 - crit
	local noms = 1 - ms
	local temp = 0
	local chance = 0
	local efct = 0
	if hd<raw_healing then
		return efct * raw_healing+(1-chance) * hd
	end
	temp = nocr*noms
	chance = chance + temp
	efct = efct + temp
	if hd<1.3*raw_healing then
		return efct * raw_healing+(1-chance) * hd
	end
	temp = ms*nocr*nocr
	chance = chance + temp
	efct = efct + 1.3*temp
	if hd<1.45*raw_healing then
		return efct * raw_healing+(1-chance) * hd
	end
	temp = crit*ms*nocr
	chance = chance + temp
	efct = efct + 1.45*temp
	if hd<1.5*raw_healing then
		return efct * raw_healing+(1-chance) * hd
	end
	temp = crit*noms
	chance = chance + temp
	efct = efct + 1.5*temp
	if hd<1.8*raw_healing then
		return efct * raw_healing+(1-chance) * hd
	end
	temp = crit*ms*nocr
	chance = chance + temp
	efct = efct + 1.8*temp
	if hd<1.95*raw_healing then
		return efct * raw_healing+(1-chance) * hd
	end
	temp = crit*crit*ms
	efct = efct + 1.95*temp
	return efct * raw_healing
end
local function mscr_pve(ms,crit,hd,raw_healing)
	local nocr = 1 - crit
	local noms = 1 - ms
	local temp = 0
	local chance = 0
	local efct = 0
	if hd<raw_healing then
		return efct * raw_healing+(1-chance) * hd
	end
	temp = nocr*noms*noms
	chance = chance + temp
	efct = efct + temp
	if hd<1.3*raw_healing then
		return efct * raw_healing+(1-chance) * hd
	end
	temp = 2*ms*nocr*nocr*noms
	chance = chance + temp
	efct = efct + 1.3*temp
	if hd<1.6*raw_healing then
		return efct * raw_healing+(1-chance) * hd
	end
	temp = ms*ms*nocr*nocr*nocr+2*crit*ms*nocr*noms
	chance = chance + temp
	efct = efct + 1.6*temp
	if hd<1.9*raw_healing then
		return efct * raw_healing+(1-chance) * hd
	end
	temp = 2*crit*ms*ms*nocr*nocr
	chance = chance + temp
	efct = efct + 1.9*temp
	if hd<2*raw_healing then
		return efct * raw_healing+(1-chance) * hd
	end
	temp = crit*noms*noms
	chance = chance + temp
	efct = efct + 2*temp
	if hd<2.2*raw_healing then
		return efct * raw_healing+(1-chance) * hd
	end
	temp = crit*crit*ms*ms*nocr
	chance = chance + temp
	efct = efct + 2.2*temp
	if hd<2.3*raw_healing then
		return efct * raw_healing+(1-chance) * hd
	end
	temp = 2*crit*ms*nocr*noms
	chance = chance + temp
	efct = efct + 2.3*temp
	if hd<2.6*raw_healing then
		return efct * raw_healing+(1-chance) * hd
	end
	temp = crit*ms*ms*nocr*nocr+2*crit*crit*ms*noms
	chance = chance + temp
	efct = efct + 2.6*temp
	if hd<2.9*raw_healing then
		return efct * raw_healing+(1-chance) * hd
	end
	temp = 2*crit*crit*ms*ms*nocr
	chance = chance + temp
	efct = efct + 2.9*temp
	if hd<3.2*raw_healing then
		return efct * raw_healing+(1-chance) * hd
	end
	temp = crit*crit*crit*ms*ms
	efct = efct + 3.2*temp
	return efct * raw_healing
end

local function erase_team_mate()
	local key
	local value
	local gtime = GetTime()
	local umap_size = 0
	local min_value = gtime + 27
	for key,value in next,unordered_map do
		if UnitInRaid(key) or UnitInParty(key) then
			unordered_map[key] = nil
		else
			if gtime<=value and value<=gtime+25 then
				umap_size = umap_size +1
				if value < min_value then
					min_value = value
				end
			else
				unordered_map[key] = nil
			end
		end
	end
	return umap_size,min_value
end

local rosterv = {}

local function update(umap_size,min_value)
	local format_str
	local members
	if UnitInRaid("player") then
		format_str = "raid"
		members = GetNumGroupMembers()
	elseif UnitInParty("player") then
		format_str = "party"
		members = GetNumGroupMembers()
	else
		format_str="player"
		members = 1
	end
	local gtime = GetTime()
	local i
	local rems= umap_size
	if(#rosterv ~= 0 ) then
		rosterv = {}
	end
	for i = 1,members,1 do
		local u
		if i == members then
			if format_str == "raid" then
				u = string_format("%s%d",format_str,i)
			else
				u = "player"
			end
		else
			u = string_format("%s%d",format_str,i)
		end
		local drtn = select(7, UnitBuff(u, rem_info, nil, "player"))
		if drtn~=nil and gtime<=drtn then
			rems = rems + 1
			if (drtn<min_value) then
				min_value = drtn
			end
			if (not UnitIsEnemy("player", u)) then
				if UnitHealth(u)<UnitHealthMax(u) then
					rosterv[#rosterv+1] = u
				end
			end
		end
	end	
	
	local primitive = (1+1.65 * GetSpellBonusHealing()) *1.2 * (1+ GetCombatRatingBonus(CR_VERSATILITY_DAMAGE_DONE)/100) * uplift_predict_factor
	if ashran == true then
		if UnitAura("PLAYER",GetSpellInfo(168506)) then
			primitive = primitive * 3	
		end
		if UnitAura("PLAYER",GetSpellInfo(173534)) or UnitAura("PLAYER",GetSpellInfo(173541)) then
			primitive = primitive * 1.15
		end
		if UnitAura("PLAYER",GetSpellInfo(173549)) then
			primitive = primitive * 1.05	
		end
	end
	local maxhl = primitive * 6
	local raw_healing = primitive
	local dcct = umap_size+#rosterv
	if auto_hide == true and rems == 0 then
		rem_frame:Hide()
		uplift_frame:Hide()
		return
	else
		rem_frame:Show()
		uplift_frame:Show()
	end
	if 6< dcct then
		raw_healing = maxhl / dcct
	end
	local amt = 0
	local hltm = #rosterv
	local crit = GetCritChance()/100
	local ms = GetMultistrike()/100
	if UnitIsPVP("player") then
		maxhl = maxhl * (1+0.3*ms) * (1+0.5*crit)
		while #rosterv ~= 0 do
			local u = rosterv[#rosterv]
			local hc = UnitHealth(u)
			local hm = UnitHealthMax(u)
			local hd = hm - hc
			if 0<hd then
				amt = amt + mscr_pvp(ms,crit,hd,raw_healing)
			end
			rosterv[#rosterv]=nil
		end
	else
		maxhl = maxhl * (1+0.6*ms) * (1+crit)
		while #rosterv ~= 0 do
			local u = rosterv[#rosterv]
			local hc = UnitHealth(u)
			local hm = UnitHealthMax(u)
			if UnitAura("PLAYER",GetSpellInfo(179986),nil,"HARMFUL") then 
				hm = hm * select(16,UnitAura("PLAYER",GetSpellInfo(179986),nil,"HARMFUL"))/100
			end
			local hd = hm - hc
			if 0<hd then
				amt = amt + mscr_pve(ms,crit,hd,raw_healing)
			end
			rosterv[#rosterv]=nil
		end
	end
	if 0 < hltm  then
		amt = amt * dcct / hltm
	end
	rem_counter:SetText(string_format("%d",rems))
	if rems < 6 then
		rem_counter:SetTextColor(1,0,0,1)
	elseif rems < 9 then
		rem_counter:SetTextColor(0,1,0,1)
	else
		rem_counter:SetTextColor(0,0,1,1)	
	end
	if min_value < 4.0 + gtime then
		rem_min_duration:SetTextColor(1,0,0,1)
	else
		rem_min_duration:SetTextColor(1,1,1,1)
	end
	if rems == 0 then
		rem_min_duration:SetText("")
	else
		rem_min_duration:SetText(string_format("%.1f",min_value-gtime))
	end
	local percent = 0
	if 0< maxhl then
		percent = amt / maxhl * 100
	end
	if percent < 40 then
		uplift_status_bar:SetStatusBarColor(0,0,1,1)
	elseif percent <80 then
		uplift_status_bar:SetStatusBarColor(0,1,0,1)
	else
		uplift_status_bar:SetStatusBarColor(1,0,0,1)
	end
	uplift_status_bar:SetValue(percent)
	uplift_percentage:SetText(string_format("%.0f%%",percent))
	uplift_amount:SetText(string_format("%d",amt))
end


local elerv,elewrmrv = {},{}
local el_info = GetSpellInfo(185158)
local function update_el(umap_size,min_value)
	local format_str
	local members
	if UnitInRaid("player") then
		format_str = "raid"
		members = GetNumGroupMembers()
	elseif UnitInParty("player") then
		format_str = "party"
		members = GetNumGroupMembers()
	else
		format_str="player"
		members = 1
	end
	local gtime = GetTime()
	local i
	local rems= umap_size
	if(#rosterv ~= 0 ) then
		rosterv = {}
	end
	if(#elerv ~= 0 ) then
		elerv = {}
	end
	if(#elewrmrv ~= 0 ) then
		elewrmrv = {}
	end

	local el_min_value = gtime+12
	local els = 0
	for i = 1,members,1 do
		local u
		if i == members then
			if format_str == "raid" then
				u = string_format("%s%d",format_str,i)
			else
				u = "player"
			end
		else
			u = string_format("%s%d",format_str,i)
		end
		local drtn = select(7, UnitBuff(u, rem_info, nil, "player"))
		local eltn = select(7, UnitBuff(u, el_info, nil, "player"))

		if drtn and  gtime <= drtn then
			rems = rems + 1
			if (drtn<min_value) then
				min_value = drtn
			end
			if eltn and gtime <= eltn then
				els = els + 1
				if (eltn<el_min_value) then
					el_min_value = eltn
				end
				if not UnitIsEnemy("player", u) and UnitHealth(u)<UnitHealthMax(u) then
					elerv[#elerv+1] = u
				end
			else
				if not UnitIsEnemy("player", u) and UnitHealth(u)<UnitHealthMax(u) then
					rosterv[#rosterv+1] = u
				end
			end
		else
			if eltn and gtime <= eltn then
				els = els + 1
				if (eltn<el_min_value) then
					el_min_value = eltn
				end
				if not UnitIsEnemy("player", u) and UnitHealth(u)<UnitHealthMax(u) then
					elewrmrv[#elewrmrv+1] = u
				end
			end
		end
	end
	
	local primitive = (1+1.65 * GetSpellBonusHealing()) *1.2 * (1+ GetCombatRatingBonus(CR_VERSATILITY_DAMAGE_DONE)/100) * uplift_predict_factor
	if ashran == true then
		if UnitAura("PLAYER",GetSpellInfo(168506)) then
			primitive = primitive * 3	
		end
		if UnitAura("PLAYER",GetSpellInfo(173534)) or UnitAura("PLAYER",GetSpellInfo(173541)) then
			primitive = primitive * 1.15
		end
		if UnitAura("PLAYER",GetSpellInfo(173549)) then
			primitive = primitive * 1.05	
		end
	end
	local raw_healing = primitive
	local dcct = umap_size+#rosterv+#elerv
	if auto_hide == true then 
		if rems == 0 then
			rem_frame:Hide()
			uplift_frame:Hide()
			el_frame:Hide()
			eluplift_frame:Hide()
			return
		end
		rem_frame:Show()
		uplift_frame:Show()
		if els == 0 then
			el_frame:Hide()
			eluplift_frame:Hide()
		else
			el_frame:Show()
			eluplift_frame:Show()
		end
	else
		rem_frame:Show()
		uplift_frame:Show()
		el_frame:Show()
		eluplift_frame:Show()
	end
	local maxhl = primitive * 6
	if 6< dcct then
		raw_healing = maxhl / dcct
	end
	maxhl = maxhl + #elerv*raw_healing*.15
	local hltm = #rosterv+#elerv
	local crit = GetCritChance()/100
	local ms = GetMultistrike()/100
	local el_healingdone = raw_healing * ( rems  +  0.15 *els )
	local bc_healingdone = el_healingdone / 2
	local maxbc_hl = els * (bc_healingdone + 0.15 * raw_healing)
	local amt = 0
	local prm = 0
	local wpprm = 0
	if UnitIsPVP("player") then
		maxhl = maxhl * (1+0.3*ms) * (1+0.5*crit)
		maxbc_hl = maxbc_hl * (1+0.3*ms) * (1+0.5*crit)
		while #rosterv ~= 0 do
			local u = rosterv[#rosterv]
			local hc = UnitHealth(u)
			local hm = UnitHealthMax(u)
			local hd = hm - hc
			if 0<hd then
				local m = mscr_pvp(ms,crit,hd,raw_healing)
				wpprm = wpprm + m
				prm = prm + m
			end
			rosterv[#rosterv]=nil
		end
		while #elerv ~= 0 do
			local u = elerv[#elerv]
			local hc = UnitHealth(u)
			local hm = UnitHealthMax(u)
			local hd = hm - hc
			if 0<hd then
				wpprm = wpprm + mscr_pvp(ms,crit,hd,raw_healing)
				prm = prm + mscr_pvp(ms,crit,hd,raw_healing*1.15)
				amt = amt + mscr_pvp(ms,crit,hd,bc_healingdone)
			end
			elerv[#elerv]=nil
		end
		while #elewrmrv ~= 0 do
			local u = elewrmrv[#elewrmrv]
			local hc = UnitHealth(u)
			local hm = UnitHealthMax(u)
			local hd = hm - hc
			if 0<hd then
				amt = amt + mscr_pvp(ms,crit,hd,bc_healingdone)
			end
			elewrmrv[#elewrmrv]=nil
		end
	else
		maxhl = maxhl * (1+0.6*ms) * (1+crit)
		maxbc_hl = maxbc_hl * (1+0.6*ms) * (1+crit)

		local hm_factor = 1
		if UnitAura("PLAYER",GetSpellInfo(179986),nil,"HARMFUL") then 
			hm_factor = select(16,UnitAura("PLAYER",GetSpellInfo(179986),nil,"HARMFUL"))/100
		end
		while #rosterv ~= 0 do
			local u = rosterv[#rosterv]
			local hc = UnitHealth(u)
			local hm = UnitHealthMax(u) * hm_factor
			local hd = hm - hc
			if 0<hd then
				local m = mscr_pve(ms,crit,hd,raw_healing)
				wpprm = wpprm + m
				prm = prm + m
			end
			rosterv[#rosterv]=nil
		end
		while #elerv ~= 0 do
			local u = elerv[#elerv]
			local hc = UnitHealth(u)
			local hm = UnitHealthMax(u) * hm_factor
			local hd = hm - hc
			if 0<hd then
				wpprm = wpprm + mscr_pve(ms,crit,hd,raw_healing)
				prm = prm + mscr_pve(ms,crit,hd,raw_healing*1.15)
				amt = amt + mscr_pve(ms,crit,hd,bc_healingdone)
			end
			elerv[#elerv]=nil
		end
		while #elewrmrv ~= 0 do
			local u = elewrmrv[#elewrmrv]
			local hc = UnitHealth(u)
			local hm = UnitHealthMax(u) * hm_factor
			local hd = hm - hc
			if 0<hd then
				amt = amt + mscr_pve(ms,crit,hd,bc_healingdone)
			end
			elewrmrv[#elewrmrv]=nil
		end
	end
	if 0 < hltm and dcct < hltm then
		prm = prm + (dcct / hltm-1)*wpprm
	end
	rem_counter:SetText(string_format("%d",rems))
	el_counter:SetText(string_format("%d",els))

	if rems < 6 then
		rem_counter:SetTextColor(1,0,0,1)
	elseif rems < 9 then
		rem_counter:SetTextColor(0,1,0,1)
	else
		rem_counter:SetTextColor(0,0,1,1)	
	end
	
	if els < 2 then
		el_counter:SetTextColor(1,0,0,1)
	elseif els < 4 then
		el_counter:SetTextColor(0,1,0,1)
	else
		el_counter:SetTextColor(0,0,1,1)	
	end
	
	if min_value < 4.0 + gtime then
		rem_min_duration:SetTextColor(1,0,0,1)
	else
		rem_min_duration:SetTextColor(1,1,1,1)
	end
	if el_min_value < 4.0 + gtime then
		el_min_duration:SetTextColor(1,0,0,1)
	else
		el_min_duration:SetTextColor(1,1,1,1)
	end
	if rems == 0 then
		rem_min_duration:SetText("")
	else
		rem_min_duration:SetText(string_format("%.1f",min_value-gtime))
	end
	if els == 0 then
		el_min_duration:SetText("")
	else
		el_min_duration:SetText(string_format("%.1f",el_min_value-gtime))
	end
	percent = 0
	if 0< maxhl then
		percent = prm / maxhl * 100
	end
	if percent < 40 then
		uplift_status_bar:SetStatusBarColor(0,0,1,1)
	elseif percent <80 then
		uplift_status_bar:SetStatusBarColor(0,1,0,1)
	else
		uplift_status_bar:SetStatusBarColor(1,0,0,1)
	end
	uplift_status_bar:SetValue(percent)
	uplift_percentage:SetText(string_format("%.0f%%",percent))
	uplift_amount:SetText(string_format("%.0f",prm))
	
	percent = 0
	if 0< maxbc_hl then
		percent = amt / maxbc_hl * 100
	end
	if percent < 40 then
		eluplift_status_bar:SetStatusBarColor(0,0,1,1)
	elseif percent <80 then
		eluplift_status_bar:SetStatusBarColor(0,1,0,1)
	else
		eluplift_status_bar:SetStatusBarColor(1,0,0,1)
	end
	eluplift_status_bar:SetValue(percent)
	eluplift_percentage:SetText(string_format("%.0f%%",percent))
	eluplift_amount:SetText(string_format("%.0f",amt))
end

local function on_update(self,elasped)
	now_timer = now_timer + elasped
	if refresh_rate<=now_timer then
		now_timer = 0
		if el_enable==true then
			if world_pvp == true then
				update_el(erase_team_mate())
			else
				update_el(0,GetTime()+27)
			end
		else
			el_frame : Hide()
			eluplift_frame : Hide()
			if world_pvp == true then
				update(erase_team_mate())
			else
				update(0,GetTime()+27)
			end
		end
	end
end
local on_update_frame=CreateFrame("Frame")
function RemUplift:PLAYER_SPECIALIZATION_CHANGED()
	if GetSpecialization() == 2 then
		self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		on_update_frame:SetScript("OnUpdate",on_update)
	else
		on_update_frame:SetScript("OnUpdate",function()end)
		rem_frame:Hide()
		uplift_frame:Hide()
		el_frame : Hide()
		eluplift_frame : Hide()
		self:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		unordered_map = {}
	end
end
